/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright (c) 2017 Oracle and/or its affiliates. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 2 only ("GPL") or the Common Development
 * and Distribution License("CDDL") (collectively, the "License").  You
 * may not use this file except in compliance with the License.  You can
 * obtain a copy of the License at
 * https://oss.oracle.com/licenses/CDDL+GPL-1.1
 * or LICENSE.txt.  See the License for the specific
 * language governing permissions and limitations under the License.
 *
 * When distributing the software, include this License Header Notice in each
 * file and include the License file at LICENSE.txt.
 *
 * GPL Classpath Exception:
 * Oracle designates this particular file as subject to the "Classpath"
 * exception as provided by Oracle in the GPL Version 2 section of the License
 * file that accompanied this code.
 *
 * Modifications:
 * If applicable, add the following below the License Header, with the fields
 * enclosed by brackets [] replaced by your own identifying information:
 * "Portions Copyright [year] [name of copyright owner]"
 *
 * Contributor(s):
 * If you wish your version of this file to be governed by only the CDDL or
 * only the GPL Version 2, indicate your decision by adding "[Contributor]
 * elects to include this software in this distribution under the [CDDL or GPL
 * Version 2] license."  If you don't indicate a single choice of license, a
 * recipient has the option to distribute your version of this file under
 * either the CDDL, the GPL Version 2 or to extend the choice of license to
 * its licensees as provided above.  However, if you add GPL Version 2 code
 * and therefore, elected the GPL Version 2 license, then the option applies
 * only if the new code is made subject to such option by the copyright
 * holder.
 */

package com.sun.xml.ws.test.xbeandoc;

import java.net.MalformedURLException;
import java.net.URL;
import javax.xml.namespace.QName;
import javax.xml.ws.Service;
import javax.xml.ws.WebEndpoint;
import javax.xml.ws.WebServiceClient;
import javax.xml.ws.WebServiceException;
import javax.xml.ws.WebServiceFeature;


/**
 * This class was generated by the JAX-WS RI.
 * JAX-WS RI 2.2.4-b01
 * Generated source version: 2.2
 *
 */
@WebServiceClient(name = "TypedXmlBeansDOCService", targetNamespace = "http://www.openuri.org/", wsdlLocation = "file:/D:/TypedXmlBeansDOCService.wsdl")
public class TypedXmlBeansDOCService
    extends Service
{

    private final static URL TYPEDXMLBEANSDOCSERVICE_WSDL_LOCATION;
    private final static WebServiceException TYPEDXMLBEANSDOCSERVICE_EXCEPTION;
    private final static QName TYPEDXMLBEANSDOCSERVICE_QNAME = new QName("http://www.openuri.org/", "TypedXmlBeansDOCService");

    static {
        URL url = null;
        WebServiceException e = null;
        try {
            url = new URL("file:/D:/TypedXmlBeansDOCService.wsdl");
        } catch (MalformedURLException ex) {
            e = new WebServiceException(ex);
        }
        TYPEDXMLBEANSDOCSERVICE_WSDL_LOCATION = url;
        TYPEDXMLBEANSDOCSERVICE_EXCEPTION = e;
    }

    public TypedXmlBeansDOCService() {
        super(__getWsdlLocation(), TYPEDXMLBEANSDOCSERVICE_QNAME);
    }

    public TypedXmlBeansDOCService(WebServiceFeature... features) {
        super(__getWsdlLocation(), TYPEDXMLBEANSDOCSERVICE_QNAME, features);
    }

    public TypedXmlBeansDOCService(URL wsdlLocation) {
        super(wsdlLocation, TYPEDXMLBEANSDOCSERVICE_QNAME);
    }

    public TypedXmlBeansDOCService(URL wsdlLocation, WebServiceFeature... features) {
        super(wsdlLocation, TYPEDXMLBEANSDOCSERVICE_QNAME, features);
    }

    public TypedXmlBeansDOCService(URL wsdlLocation, QName serviceName) {
        super(wsdlLocation, serviceName);
    }

    public TypedXmlBeansDOCService(URL wsdlLocation, QName serviceName, WebServiceFeature... features) {
        super(wsdlLocation, serviceName, features);
    }

    /**
     *
     * @return
     *     returns TypedXmlBeansDOC
     */
    @WebEndpoint(name = "TypedXmlBeansDOCSoapPort")
    public TypedXmlBeansDOC getTypedXmlBeansDOCSoapPort() {
        return super.getPort(new QName("http://www.openuri.org/", "TypedXmlBeansDOCSoapPort"), TypedXmlBeansDOC.class);
    }

    /**
     *
     * @param features
     *     A list of {@link javax.xml.ws.WebServiceFeature} to configure on the proxy.  Supported features not in the <code>features</code> parameter will have their default values.
     * @return
     *     returns TypedXmlBeansDOC
     */
    @WebEndpoint(name = "TypedXmlBeansDOCSoapPort")
    public TypedXmlBeansDOC getTypedXmlBeansDOCSoapPort(WebServiceFeature... features) {
        return super.getPort(new QName("http://www.openuri.org/", "TypedXmlBeansDOCSoapPort"), TypedXmlBeansDOC.class, features);
    }

    private static URL __getWsdlLocation() {
        if (TYPEDXMLBEANSDOCSERVICE_EXCEPTION!= null) {
            throw TYPEDXMLBEANSDOCSERVICE_EXCEPTION;
        }
        return TYPEDXMLBEANSDOCSERVICE_WSDL_LOCATION;
    }

}
